package djmil.cordacheckers;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.security.provisioning.InMemoryUserDetailsManager;

@Configuration
public class SecurityConfig {

    @Bean
    PasswordEncoder passwordEncoder() {
        return new BCryptPasswordEncoder();
    }

    @Bean
    UserDetailsService hardcodedCordaUsers(PasswordEncoder passwordEncoder) {
        User.UserBuilder users = User.builder();
	
        UserDetails alice = users
            .username("alice")
            .password(passwordEncoder.encode("qaz123"))
            .build();

        UserDetails bob = users
            .username("bob")
            .password(passwordEncoder.encode("qaz123"))
            .build();
        
        return new InMemoryUserDetailsManager(alice, bob);
    }

}
